\documentclass{scrarticle}
\usepackage{hyperref}
\usepackage{titling}
\usepackage{graphicx}
\usepackage{float}
\usepackage{booktabs}
\usepackage{color}
\usepackage{tikz}
\usepackage{pgfgantt}
\usepackage{rotating}
\pagenumbering{arabic}

%Let's define some awesome new ganttchart elements:
\newganttchartelement{orangebar}{
    orangebar/.style={
        inner sep=0pt,
        draw=red!66!black,
        very thick,
        top color=white,
        bottom color=orange!80
    },
    orangebar label font=\slshape,
    orangebar left shift=.1,
    orangebar right shift=-.1
}

\newganttchartelement{bluebar}{
    bluebar/.style={
        inner sep=0pt,
        draw=purple!44!black,
        very thick,
        top color=white,
        bottom color=blue!80
    },
    bluebar label font=\slshape,
    bluebar left shift=.1,
    bluebar right shift=-.1
}

\newganttchartelement{greenbar}{
    greenbar/.style={
        inner sep=0pt,
        draw=green!50!black,
        very thick,
        top color=white,
        bottom color=green!80
    },
    greenbar label font=\slshape,
    greenbar left shift=.1,
    greenbar right shift=-.1
}

\newganttchartelement{graybar}{
    graybar/.style={
        inner sep=0pt,
        draw=gray!50!black,
        very thick,
        top color=white,
        bottom color=gray!80
    },
   graybar label font=\slshape,
   graybar left shift=.1,
   graybar right shift=-.1
}

\newganttchartelement{yellowbar}{
    yellowbar/.style={
        inner sep=0pt,
        draw=white,
        thick,
        top color=white,
        bottom color=white
    },
   yellowbar label font=\slshape,
   yellowbar left shift=.1,
   yellowbar right shift=-.1
}

\input{solidity-highlighting}


\begin{document}
\title{Integrating IoT in a Decentralized
Renting Application} %TODO: Fill in project name
\author{%TODO: Fill in your names
	Lieb, Alexander (Alexander.Lieb@online.de) 
	\and \\
	Rüdesheim, Lennard (lennard.ruedesheim@stud.tu-darmstadt.de)
%TODO uncomment for more authors
%	\and \\
%	LastName3, FirstName3
%	\and \\
%	LastName4, FirstName4
}
%\author{team member 1\\ team member 2\\ team member 3} %TODO: Fill in your names
\input{titlepage_progress_report}
\clearpage

\paragraph{Abstract.}
\begin{abstract}
%Summarize the motivation and main concepts of your project (1/2 page). 
The business model of the sharing economy is based on interactions between the consumers of a platform. Popular examples for platforms in the market are Airbnb and Uber. They offer a service for users to rent their flat or a driving service. In this setting the platform provider has the power to decide who has access to his services and can demand significant fees for users. There is also a lack of privacy for the participants.

We want to develop a Decentralised App (DAPP) based on a smart contract  on the Ethereum blockchain to allow transactions between an owner of a product and a renter, so that no such platform provider is needed. Our application shall enable users to rent their bike. In this application we want to integrate an IoT device through that we want to reduce the effort for the users. The IoT device shall control the lock of the bike and should be able to locate it. Thereby the location of the bike can be used to determine the fee for renting and to make sure that the bike can only be returned at certain positions. 

%An additional goal is to minimize the gas costs of the application. This is important
%since the fees an user has to pay for using the DAPP should be small compared to the
%costs using a traditional platform provider.
\end{abstract}

\newpage
\section{Status Report}

In the last four weeks we worked on our first two milestones. The first milestone, Working Renting System, was finished at the May 11, 2020 with the help of David Kretzler in the function of the scrum product owner. The second milestone is not fully achieved yet, mainly due to missing or failing hardware.


\subsection{Milestone: Working Renting System}

The first milestone included three user stories. The first one was, that a user has to be able to add a bike to the application. The second user story was, that a user has to be able to rent an offered bike, which is available. The last user story was, that a user has to be able to return a bike, (s)he rented before.

To fulfill all of these, we developed a DAPP, using Truffle, Ganache, Metamask, Google Chrome, Mozilla Firefox and the web3.js javascript library. Using this DAPP, a user is able to announce a bike for availability, hirer a bike, return a bike, and remove his/her bike from the system. The system is city-based, which means, that each city has its own contract and the user can choose the city. If there is no contract for the searched region, the user can deploy and register one by himself/herself.

Appendix A shows some impressions of the user interface, while Appendix B shows the code for the two basic contracts. There is at least one master contract needed. The address of the master contract is hardcoded in the DAPP and represents a meeting point for all users who want to participate in the system. Each city, which is part of the system, gets its own city contract, which has to be registered at the master contract. Therefore each user can choose the city to prevent that each user has to search through all bike offers in the world.

\subsection{Milestone: IoT device is working}

The second milestone includes three user stories, where two of them are right now not finished due to missing or failing hardware. The working user story is that the raspberry pi is able to get the GPS data from the GPS module. The second user story is that the RPI can access the LTE stick. The third user story is about the ability to lock and unlock the bike.

To fulfill the first user story, we implemented a python module, which enables a developer to get up to date information about time, latitude, and longitude. Appendix C shows this module, which basically consists of two classes. The gpsdata class is a data-only class, which is used to store the actual time and position. This class is also returned, in case another python module uses this. The gpsgetter starts a new thread, which accesses the serial console and updates the data. Its using an own thread for accessing the serial console where the GPS module is attached. We soldered some pins to the GPS board to have a stable connection to the raspberry pi.

To fulfill the second user story, the raspberry pi needs to have access to the LTE stick. While this is indeed possible, the LTE stick is not able to access the internet. Right now, we are in touch with the merchant and the problem will be solved as soon as possible.

For the bike lock, a step motor is needed. The step motor is not delivered yet and therefore the bike lock was not built, yet.

\newpage
\section{Updated Project Plan}
%Update your project plan. Make sure to include reached milestones and mark changes to the original plan.

We had to update our project plan, because of the delayed delivery of the step motor for our bike lock. Thereby we moved User Stories 7 and 9 to Sprint 4 and depending on the arrival we will also move User Story 5 to Sprint 4 (see figure \ref{fig:plan}). In table \ref{tab:mile} you can see the state of our milestones and the associated User Stories.

We also added the mandatory submission to our project plan to have an better overview over the workload in the sprints (see figure \ref{fig:plan}). 


\begin{table}[!h]
 \begin{tabular}{p{4cm}p{5cm}p{5cm}}
\toprule
\textbf{Milestones} & \textbf{Open User Stories}  &  \textbf{ Finished User Stories }\\
\midrule
\textbf{Working \linebreak Renting System} \newline (finished)& - & US1: User can add a bike (Sprint 1)   \\  
    &  & \\
 & &US2: User is able to rent a bike (Sprint 1) \\
     &  & \\
  & & US3: User is able to release a bike (Sprint 1)\\
   \midrule
  \textbf{IoT device is working}  & US4: RPI can access the LTE Stick (Sprint 3, moved from Sprint 2) & US6: User can get GPS data from RPI (Sprint 2)\\
       & & \\
    & US5: The RPI can lock the bike (Sprint 4, moved from sprint 2) & \\
    & & \\
    \midrule
 \textbf{IoT device is connected to the \newline contract}  & US7: Smart Contract locks the bike when it is released (Sprint 4, moved from sprint 3) & - \\
    & & \\
     & US8: Bike posts the distance it has traveled (Sprint 3)& \\
         & & \\
    & US9: User is able to unlock the bike through the Smart Contract (Sprint 4, moved from sprint 3)& \\
\bottomrule
 \end{tabular}
 \caption{Project Milestones}  \label{tab:mile}
\end{table}

%\begin{table}[!h]
% \begin{tabular}{p{1.5cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}p{1.9cm}}
%\toprule
%\textbf{Sprint} & 27.04 \newline- 11.05 & 11.05 \newline- 25.05 & 25.05 \newline- 08.06 & 08.06 \newline- 22.06 & 22.06 \newline- 06.07 & 06.07 \newline- 20.07  \\
%\midrule
%\textbf{User Stories} & US 1,2,3 & US 6 \newline Progess Report 1 & US 4,8 & US 5,7,9 \newline Progress Report 2 &  Final report & TEE Integration\newline (optional)\\
%\bottomrule
% \end{tabular}
 %\caption{Project Plan}  \label{tab:plan}
%\end{table}

\begin{minipage}{\linewidth}
\centering
\begin{sideways}

\begin{ganttchart}[
    hgrid style/.style={black, dotted},
    vgrid={*5{black,dotted}, *1{white, dotted}, *1{black, dashed}},
    x unit=2mm,
    y unit chart=7.5mm,
    y unit title=10mm,
    time slot format=isodate,
    group label font=\bfseries \Large,
    link/.style={->, thick}
    ]{2020-04-27}{2020-07-26}
    \gantttitlecalendar{month=name, week}\\

    \ganttgroup[
        group/.append style={fill=orange}
    ]{Milestone 1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US1
    ]{US1}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US2
    ]{US2}{2020-04-27}{2020-05-11}\\ [grid]
    \ganttorangebar[
        name=US3
    ]{US3}{2020-04-27}{2020-05-11}\\ [grid]


    \ganttgroup[
        group/.append style={fill=blue}
    ]{Milestone 2}{2020-05-11}{2020-06-22} \\[grid]
    \ganttbluebar{US4}{2020-05-25}{2020-06-08}\\ [grid]
    \ganttbluebar{US5}{2020-06-08}{2020-06-22} \\[grid]
    \ganttbluebar{US6}{2020-05-11}{2020-05-25} \\[grid]

    \ganttgroup[
        group/.append style={fill=green}
    ]{Milestone 3}{2020-05-25}{2020-06-22} \\[grid]
    \ganttgreenbar{US7}{2020-06-08}{2020-06-22}\\ [grid]
    \ganttgreenbar{US8}{2020-05-25}{2020-06-08} \\[grid]
    \ganttgreenbar{US9}{2020-06-08}{2020-06-22} \\[grid]


    \ganttgroup[
        group/.append style={fill=gray}
    ]{Submissions}{2020-04-27}{2020-07-19} \\[grid]
    \ganttgraybar{Progress Report 1}{2020-05-18}{2020-05-24}\\ [grid]
    \ganttgraybar{Progress Report 2}{2020-06-15}{2020-06-21} \\[grid]
    \ganttgraybar{Final Report}{2020-06-22}{2020-07-19} \\[grid]
    
        \ganttgroup[
        group/.append style={fill=yellow}
    ]{TEE Integration}{2020-07-06}{2020-07-19} \\[grid]
    
   \ganttyellowbar{(optional)}{2020-07-19}{2020-07-19} \\[grid]

\end{ganttchart}

\end{sideways}
\captionof{figure}{Project Plan } \label{fig:plan}
\end{minipage}
\newpage
\section*{Appendix A}

\begin{figure}[H]
  \centering
  \begin{tabular}{@{}c@{\hspace{.5cm}}c@{}}
    \includegraphics[page=1,width=0.8\textwidth]{img/Screenshot_Master_UI.pdf}
  \end{tabular}
  \caption{Screenshot of the User Interface, Master Contract}
\end{figure}

\begin{figure}[H]
  \centering
  \begin{tabular}{@{}c@{\hspace{.5cm}}c@{}}
    \includegraphics[page=1,width=0.8\textwidth]{img/Screenshot_City_UI.pdf}
  \end{tabular}
  \caption{Screenshot of the User Interface, City Contract}
\end{figure}

\newpage
\section*{Appendix B}

\begin{lstlisting}[language=Solidity]
pragma solidity 0.5.16;

contract Master{
  struct city {
    string country;
    string state;
    string city;
    address place;
  }

  event cityRegisteredEvent(
    string name
  );
  
  city[] public registeredCities;

  function getNoOfCities() external view returns (uint) {
    return registeredCities.length;
  }

  function getCity(uint which) external view returns (string memory){
    return string(abi.encodePacked(registeredCities[which].city, ",", registeredCities[which].state, ",", registeredCities[which].country));
  }

  function getPlace(uint which) external view returns (address) {
    return registeredCities[which].place;
  }
  
  function register(string calldata _country, string calldata _state, string calldata _city, address _place) external {
    registeredCities.push(city(_country, _state, _city, _place));
    emit cityRegisteredEvent(_city);
  }
  
}
\end{lstlisting}

\newpage

\begin{lstlisting}[language=Solidity]
pragma solidity 0.5.16;
import "../../Master_Contract/contracts/Master.sol";

contract Renting{

     struct Bike{
       address owner;
       uint hirer_refund;
       uint base_price;
       // 0 indicates that this bike is not hired yet
       address hirer;
       uint amount_hirer_paid;
    }

    mapping(uint => Bike) public bikes;
    mapping(address => uint) public refunds;
    
    uint public bikeCount;

    // TODO: find a "good" value or add it to the constructor
    uint public constant owner_refund = 42;
    
    //events
    event addBikeEvent(
       uint bikeId
    );

    event rentBikeEvent(
       uint bikeId
    );

    event returnBikeEvent(
      uint bikeId
    );

    event removeBikeEvent(
      uint bikeId
    );

    event refundEvent();

    // Constructor
    constructor(string memory _country, string memory _state, string memory _city, address _master_address) public{

	Master m = Master(_master_address);
	m.register(_country, _state, _city, address(this));
	
    }

    //adds bike to the bikes mapping with the specified costs
    function addBike(uint _base_price, /*uint _cpkm,*/ uint _hirer_refund) external payable{
      require(msg.value >=  owner_refund);
      bikeCount ++;
      bikes[bikeCount] = Bike(msg.sender, _hirer_refund, _base_price, address(0), 0);
      emit addBikeEvent(bikeCount); 
    }


    function rentBike(uint _bikeId) external payable{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == address(0), "Bike is already rented");
      require(bikes[_bikeId].hirer_refund + bikes[_bikeId].base_price <= msg.value, "Message Value to low");

      bikes[_bikeId].hirer = msg.sender;
      bikes[_bikeId].amount_hirer_paid = msg.value;
	
      emit rentBikeEvent(_bikeId); 
    }

    function returnBike(uint _bikeId) external{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == msg.sender, "You are not the renter of the bike");
	
      bikes[_bikeId].hirer = address(0);

      uint fund = bikes[_bikeId].amount_hirer_paid - bikes[_bikeId].base_price;
      bikes[_bikeId].amount_hirer_paid = 0;
      
      refunds[bikes[_bikeId].owner] += bikes[_bikeId].base_price;
      //refunds[bikes[_bikeId].hirer] += fund;
      msg.sender.transfer(fund);
      
      emit returnBikeEvent(_bikeId);
    }

    function removeBike(uint _bikeId) external{
      require(bikes[_bikeId].owner != address(0), "Bike-ID not valid");
      require(bikes[_bikeId].hirer == address(0), "Bike is rented");
      require(bikes[_bikeId].owner == msg.sender, "You are not the owner of the bike");
      refunds[bikes[_bikeId].owner] += owner_refund;
      delete bikes[_bikeId];
      emit removeBikeEvent(_bikeId);
    }

    function refund() external{
      uint amount = refunds[msg.sender];
      refunds[msg.sender] = 0;
      emit refundEvent(); 
      msg.sender.transfer(amount);
    }
}
\end{lstlisting}
\newpage

\section*{Appendix C}

\begin{lstlisting}[language = python]
import os
import struct
from threading import Thread
import time
from serial import Serial

class gpsdata:
    def __init__(self, time, n, e):
        self.time = time
        self.n = n
        self.e = e

    def get_time(self):
        return self.time

    def get_n(self):
        return self.n

    def get_e(self):
        return self.e

class gpsgetter:
    
    def helper(loself):
        ser=Serial('/dev/ttyS0')
        ser.flushInput()
        while True:
            try:
                bytes = ser.readline()
                text = bytes.decode("utf-8")
                if (text.find("GPGGA") >= 0):
                    arr = text.split(',')
                    loself.set_values(gpsdata(arr[1], arr[2], arr[4]))
                    time.sleep(30)
                    ser.flushInput()
            except Exception as ex:
                print(ex)
                break
            
    def start_getter(self):
        self.actual = gpsdata(0, 0, 0)
        self.runner = Thread(target=gpsgetter.helper, args=[self])
        self.runner.start()

    def get_values(self):
        return self.actual

    def set_values(self, new):
        self.actual = new

\end{lstlisting}


\bibliographystyle{unsrt}
\bibliography{ref}

\end{document}
